/**
 * @file conf.h 
 * 
 * Project configuration
 * 
 * @author Tecnologix, 2015
 */
#ifndef TLXDEMO_CONF_H
#define TLXDEMO_CONF_H

/* ---------------------------------------------------------------------------------
 * FILTERS 
 * --------------------------------------------------------------------------------- */

#define WINDOWED_SINC_LP_500HZ        (1)
#define MOVING_AVG_10                 (2)
#define IIR_BWORTH2_LP_500HZ          (3)
#define WINDOWED_SYNC_BP_1200_1700HZ  (4)
#define IIR_BWORTH2_HP_3000HZ         (5)
#define IIR_BWORTH2_HP_3500HZ         (6)
/* Extend the list adding your own filters herebelow */

/* Example 1 */
#ifdef EXAMPLE1

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR WINDOWED FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_WS_ACTIVE_FILTER        WINDOWED_SINC_LP_500HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR MOVING AVERAGE FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_MA_ACTIVE_FILTER        MOVING_AVG_10
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR F32 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define IIR_F32_ACTIVE_FILTER       IIR_BWORTH2_LP_500HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR Q15 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */
  #define IIR_Q15_POST_SHIFT          (1)
  #define IIR_Q15_ACTIVE_FILTER       IIR_BWORTH2_LP_500HZ
  /* Extend the list adding your own filters herebelow */
  
#endif

/* Example 2 */
#ifdef EXAMPLE2

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR WINDOWED FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_WS_ACTIVE_FILTER        WINDOWED_SYNC_BP_1200_1700HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR MOVING AVERAGE FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_MA_ACTIVE_FILTER        MOVING_AVG_10
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR F32 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define IIR_F32_ACTIVE_FILTER       IIR_BWORTH2_HP_3000HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR Q15 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */
  #define IIR_Q15_POST_SHIFT          (1)
  #define IIR_Q15_ACTIVE_FILTER       IIR_BWORTH2_LP_500HZ
  /* Extend the list adding your own filters herebelow */

#endif

/* Example 3 */
#ifdef EXAMPLE3

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR WINDOWED FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_WS_ACTIVE_FILTER        WINDOWED_SINC_LP_500HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR MOVING AVERAGE FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_MA_ACTIVE_FILTER        MOVING_AVG_10
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR F32 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define IIR_F32_ACTIVE_FILTER       IIR_BWORTH2_HP_3500HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR Q15 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */
  #define IIR_Q15_POST_SHIFT          (0)
  #define IIR_Q15_ACTIVE_FILTER       IIR_BWORTH2_HP_3500HZ
  /* Extend the list adding your own filters herebelow */

#endif

/* Example 4 */
#ifdef EXAMPLE4

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR WINDOWED FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_WS_ACTIVE_FILTER        WINDOWED_SYNC_BP_1200_1700HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE FIR MOVING AVERAGE FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */

  #define FIR_MA_ACTIVE_FILTER        MOVING_AVG_10
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR F32 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */
  
  #define IIR_F32_ACTIVE_FILTER       IIR_BWORTH2_LP_500HZ
  /* Extend the list adding your own filters herebelow */

  /* ---------------------------------------------------------------------------------
   * ENABLE HERE THE IIR Q15 FILTER YOU WANT TO USE
   * --------------------------------------------------------------------------------- */
  #define IIR_Q15_POST_SHIFT          (0)
  #define IIR_Q15_ACTIVE_FILTER       IIR_BWORTH2_HP_3500HZ
  /* Extend the list adding your own filters herebelow */

#endif



#endif
