/**
 * @file lcd_env.h 
 * 
 * LCD environment function prototypes
 * 
 * @author Tecnologix, 2015
 */
#ifndef LCD_ENV
#define LCD_ENV

#include <stdbool.h>
#include <stdint.h>

/* ===============================================================================
 * MACROS
 * =============================================================================== */


#define GRAPH_X_SIZE              (460)
#define GRAPH_Y_SIZE              (220)


/* ===============================================================================
 * FUNCTION PROTOTYPES
 * =============================================================================== */

/** 
 * Initialize the LCD graph
 */
void lcd_graph_init(void);

/** 
 * Show graph
 */
void lcd_graph_show(short * pData1_in, short * pData1_out, 
                    short * pData2_in, short * pData2_out, 
                    uint16_t d1_scale, uint16_t d2_scale, 
                    uint16_t d1_n_data, uint16_t d2_n_data,
                    uint16_t left_trans, uint16_t right_trans);


#endif
